

#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/proc_fs.h>
#include <asm/uaccess.h>
#include <linux/init.h>

#define DRIVER_AUTHOR  "httel<www.httel.com>"

/* Deal with CONFIG_MODVERSIONS 
#if CONFIG_MODVERSIONS==1
#define MODVERSIONS
#include <linux/modversions.h>
#endif
*/

#define __NO_VERSION__

#ifndef KERNEL_VERSION
#define KERNEL_VERSION(a,b,c) (((a) << 16) + ((b) << 8) + (c))
#endif

#define MESSAGE_LENGTH 30
#define NETHID_FIT_LEN 20
#define PROC_ENTRY_FILENAME "nethid_eth1"

struct nethid_fit
{
	unsigned int ip;
	unsigned char tag;
	unsigned short p_min;
	unsigned short p_max;
	struct nethid_fit * next;
};

static struct proc_dir_entry *Our_Eth1_File;

extern struct nethid_fit Bl_fit_eth1[NETHID_FIT_LEN];
extern struct nethid_fit * End_eth1_fit;

/*-------------------------------------------------------------------------------
* function : static unsigned short chois(char * str)
* call     :    
* parameter:
* return   :   
* show     :  将字符串转化为数字 
************************************hoohoo**************************************
-------------------------------------------------------------------------------*/
static unsigned short chois(char * str)
{
    unsigned short num;
    unsigned short sum = 0;
    for(num = 0; *(str + num) != '\0'; num++);
    if(!num)
    {
        return sum;
    }
    num--;
    sum += (*(str + num) & 0x0f);
    if(!num)
    {
        return sum;
    }
    num--;
    sum += (*(str + num) & 0x0f) * 10;
    if(!num)
    {
        return sum;
    }
    num--;
    sum += (*(str + num) & 0x0f) * 100;
    if(!num)
    {
        return sum;
    }
    num--;
    sum += (*(str + num) & 0x0f) * 1000;
    if(!num)
    {
        return sum;
    }
    num--;
    sum += (*(str + num) & 0x0f) * 10000;
    
    return sum;

} 
static ssize_t module_output(struct file *filp,	/* see include/linux/fs.h   */
			     char *buffer,	/* buffer to fill with data */
			     size_t length,	/* length of the buffer     */
			     loff_t * offset)
{
	static int finished = 0;
	struct nethid_fit * tmp_point = Bl_fit_eth1;
	int i = 0;
	int j;
	unsigned char tmp_ip[4];

	char message[MESSAGE_LENGTH + 30];

	if (finished) {
		finished = 0;
		return 0;
	}
	
	while(tmp_point != End_eth1_fit)
	{
		tmp_ip[0] = *((unsigned char *)tmp_point);
		tmp_ip[1] = *((unsigned char *)tmp_point + 1);
		tmp_ip[2] = *((unsigned char *)tmp_point + 2);
		tmp_ip[3] = *((unsigned char *)tmp_point + 3);

		sprintf(message, "accept: %d.%d.%d.%d %c %d %d\n", tmp_ip[0],tmp_ip[1],tmp_ip[2],tmp_ip[3],tmp_point->tag,tmp_point->p_min,tmp_point->p_max);
		for (j = 0; i < length && message[j]; j++)
		{
			put_user(message[j], buffer + i);
			i++;
		}
		tmp_point++;
	}
	finished = 1;

	return i;		/* Return the number of bytes "read" */
}

static ssize_t module_input(struct file *filp, const char *buff, size_t len, loff_t * off)
{
	int i;
	unsigned char count = 0;
	char tmp;
	char str[10] ;
	char * pstr = str;

	End_eth1_fit = Bl_fit_eth1;

	for (i = 0; (i < 800) && (i < len); i++)
	{
		get_user(tmp, buff + i);
		if(tmp == '\x20')
		{	
			if(str == pstr)
			{
				continue;
			}
			*pstr = '\0';
			pstr = str;
			if(count < 4)
			{
				*((unsigned char *)End_eth1_fit + count) = (unsigned char)chois(str);
				count++;
				continue;
			}
			if(count == 4)
			{
				End_eth1_fit->tag = *str;
				count++;
				continue;
			}
			if(count == 5)
			{
				End_eth1_fit->p_min = chois(str);
				count++;
				continue;
			}
			if(count == 6)
			{
				End_eth1_fit->p_max = chois(str);
				count = 0;
				End_eth1_fit++;
				if(End_eth1_fit == (Bl_fit_eth1 + NETHID_FIT_LEN))
				{
					return len;
				}
				continue;
			}
			return len;
		}
		if(tmp == '.')
		{
			if(str == pstr)
			{
				continue;
			}
			if(count > 3)
			{
				return len;
			}
			*pstr = '\0';
			pstr = str;
			*((unsigned char *)End_eth1_fit + count) = (unsigned char)chois(str);
			count++;
			continue;
		}
		if(tmp == '\x0a')
		{
			if(count == 6 && str != pstr)
			{
				End_eth1_fit->p_max = chois(str);
				count = 0;
				End_eth1_fit++;
			}
		}
		*pstr = tmp;
		pstr++;

	}

	return i;
}


static int module_permission(struct inode *inode, int op, struct nameidata *foo)
{

	if (op == 4 || (op == 2 && current->euid == 0))
		return 0;

	return -EACCES;
}


int module_open(struct inode *inode, struct file *file)
{
	try_module_get(THIS_MODULE);
	/*MOD_INC_USE_COUNT;*/
	return 0;
}

/* 
 * The file is closed - again, interesting only because
 * of the reference count. 
 */
int module_close(struct inode *inode, struct file *file)
{
	module_put(THIS_MODULE);
	/*MOD_DEC_USE_COUNT;*/
	return 0;		/* success */
}

static struct file_operations File_Ops_4_Our_Eth1_File = {
	.read = module_output,
	.write = module_input,
	.open = module_open,
	.release = module_close,
};


static struct inode_operations Inode_Ops_4_Our_Eth1_File = {
	.permission = module_permission,	/* check for permissions */
};

int init_module(void)
{
	int rv = 0;
	Our_Eth1_File = create_proc_entry(PROC_ENTRY_FILENAME, 0644, NULL);
	Our_Eth1_File->owner = THIS_MODULE;
	Our_Eth1_File->proc_iops = &Inode_Ops_4_Our_Eth1_File;
	Our_Eth1_File->proc_fops = &File_Ops_4_Our_Eth1_File;
	Our_Eth1_File->mode = S_IFREG | S_IRUGO | S_IWUSR;
	Our_Eth1_File->uid = 0;
	Our_Eth1_File->gid = 0;
	Our_Eth1_File->size = 80;
	
	if (Our_Eth1_File == NULL) {
		rv = -ENOMEM;
		remove_proc_entry(PROC_ENTRY_FILENAME, &proc_root);
		printk(KERN_INFO "Error: Could not initialize /proc/nethid_eth1\n");
	}

	return rv;
}

void cleanup_module(void)
{
	remove_proc_entry(PROC_ENTRY_FILENAME, &proc_root);
}



MODULE_LICENSE("GPL");

MODULE_AUTHOR(DRIVER_AUTHOR );
/*
  module_init(hidpf1_init);  
  module_exit(hidpf1_exit);   
*/
