
#include<linux/init.h>
#include<linux/module.h>
#include<linux/time.h>
#include<linux/sched.h>

MODULE_AUTHOR("HTTEL");
MODULE_LICENSE("GPL");



#define  RTP_DYN_TAB_LEN     2000
#define  SIP_DYN_TAB_LEN     20000  
#define RTP_TABLE_LEN        	500
#define SIP_TABLE_LEN		1000
#define TABLE_NULL			0
#define TABLE_USE			2
#define TABLE_DEL			1

struct note_table        /* register IP and port of client */
{
    	unsigned int key_ip;
    	unsigned short key_port;
    	unsigned short sign;
	struct note_table * next;
};

extern struct note_table  sip_iport_table[SIP_TABLE_LEN];	/*define register table*/
extern struct note_table  rtp_iport_table[RTP_TABLE_LEN];	/*define register table*/

extern struct note_table dyn_rtp_table[RTP_DYN_TAB_LEN];
extern struct note_table dyn_sip_table[SIP_DYN_TAB_LEN];

extern spinlock_t sip_lock;
extern spinlock_t rtp_lock;

extern unsigned short state_sip_table;
extern unsigned short state_rtp_table;

static struct timer_list  sip_tab_timer;
static struct timer_list  rtp_tab_timer;

static int link_tab(struct note_table * tab_point)
{
	struct note_table * link_point;
	struct note_table * tmp_point;
	link_point = tab_point;

	if(link_point->sign == 0)
	{
		return 0;
	}
	link_point->sign--;
	link_point = link_point->next;
	while(link_point !=0)
	{
		link_point->sign--;
		link_point = link_point->next;
	}
	link_point = tab_point;

	while(link_point->next !=0)
	{
		if((link_point->next)->sign == 0)
		{
			(link_point->next)->key_ip = 0;
			(link_point->next)->key_port = 0;
			tmp_point = (link_point->next)->next;
			(link_point->next)->next = 0;
			link_point->next = tmp_point;
		}
		else
		{
			link_point = link_point->next;
		}
	}
	if(tab_point->sign == 0)
	{
		if(tab_point->next != 0)
		{
			tab_point->key_ip = (tab_point->next)->key_ip;
			tab_point->key_port = (tab_point->next)->key_port;
			tab_point->sign = (tab_point->next)->sign;
			tmp_point = (tab_point->next)->next;
			(tab_point->next)->key_ip = 0;
			(tab_point->next)->key_port = 0;
			(tab_point->next)->sign = 0;
			(tab_point->next)->next = 0;
			tab_point->next = tmp_point;	
		}
	}
	
	return 0;
}

void  table_sip_func(unsigned long data)
{
	unsigned short num;
	struct note_table * tab_point;

	tab_point = sip_iport_table;
	if(state_sip_table)
	{
		mod_timer(&sip_tab_timer,jiffies+1800*HZ);
		return;
	}
	for(num = 0; num < SIP_TABLE_LEN; num++)
	{
		spin_lock(&sip_lock);
		link_tab(tab_point);
		spin_unlock(&sip_lock);
		tab_point++;
		
	}
	
	mod_timer(&sip_tab_timer,jiffies+1800*HZ);
}

void  table_rtp_tfunc(unsigned long data)
{
	unsigned short num;
	struct note_table * tab_point;
	tab_point = rtp_iport_table;
	if(state_rtp_table)
	{
		mod_timer(&rtp_tab_timer,jiffies+40*HZ);
		return;
	}

	for(num = 0; num < RTP_TABLE_LEN; num++)
	{
		spin_lock(&rtp_lock);
		link_tab(tab_point);
		spin_unlock(&rtp_lock);
		tab_point++;
	}
	
	mod_timer(&rtp_tab_timer,jiffies+40*HZ);
}

int init_module(void)
{  
 	init_timer(&sip_tab_timer);  
 	sip_tab_timer.data=1212;  
 	sip_tab_timer.function=table_sip_func;  
  	sip_tab_timer.expires=jiffies+1800*HZ;     
    	add_timer(&sip_tab_timer);  

	init_timer(&rtp_tab_timer);  
 	rtp_tab_timer.data=1212;  
 	rtp_tab_timer.function=table_rtp_tfunc;  
 	rtp_tab_timer.expires=jiffies+40*HZ;  
 	add_timer(&rtp_tab_timer); 

      return   0;  
  }  
   
void cleanup_module(void)
  {  

      		del_timer(&sip_tab_timer); 
     		del_timer(&rtp_tab_timer); 
  }  
/*  
  module_init(timer_init);  
  module_exit(timer_exit);   
*/
