/*
#define __KERNEL__
#define MODULE
*/


#define OUTSIDE_INERTFACE      "eth0"
#define INSIDE_INETRFACE    "eth1"


#define IP_UDP          0x11 




#include<linux/module.h>
#include<linux/kernel.h>
#include<linux/netfilter.h>
#include<linux/netfilter_ipv4.h>
#include<linux/init.h>
#include<linux/udp.h>
#include<linux/in.h>        
#include<linux/ip.h>
#include<linux/netdevice.h>
#include<linux/skbuff.h>

/*
#include<linux/spinlock.h>
#include<asm/uaccess.h>
*/
#define DRIVER_AUTHOR  "httel<www.httel.com>"
#define DRIVER_DESC         "nethidepro 3.0.0"

/*
#if CONFIG_MODVERSIONS==1
#define MODVERSIONS
#include<linux/modversions.h>
#endif
*/

#define VOIP_KEY_end   0x53

unsigned short voip_key = 0x5448;
unsigned char voip_key_h = 0x48;
unsigned char voip_key_l = 0x54;

unsigned short net_state = 0;		/*控制软件运行状态*/



module_param(voip_key,ushort,0);
module_param(net_state,ushort,0);		/*获得命令行参数*/

#define MOTHOD_LEN 14

unsigned char * methode_key[MOTHOD_LEN] ;
unsigned char * methode[MOTHOD_LEN] ;

unsigned char method0[] = "\x07INVITE ";
unsigned char method1[] = "\x04\x41\x43K ";
unsigned char method2[] = "\x08OPTIONS ";
unsigned char method3[] = "\x04\x42YE ";
unsigned char method4[] = "\x07\x43\x41NCEL ";
unsigned char method5[] = "\x09REGISTER ";
unsigned char method6[] = "\x07SIP/2.0";
unsigned char method7[] = "\x07NOTIFY ";
unsigned char method8[] = "\x06PRACK ";
unsigned char method9[] = "\x07UPDATE ";
unsigned char method10[] = "\x08MESSAGE ";
unsigned char method11[] = "\x06REFER ";
unsigned char method12[] = "\x0Are-INVITE ";
unsigned char method13[] = "\x0ASUBSCRIBE ";


unsigned char method0_k[] = "\x07INVITE ";
unsigned char method1_k[] = "\x04\x41\x43K ";
unsigned char method2_k[] = "\x08OPTIONS ";
unsigned char method3_k[] = "\x04\x42YE ";
unsigned char method4_k[] = "\x07\x43\x41NCEL ";
unsigned char method5_k[] = "\x09REGISTER ";
unsigned char method6_k[] = "\x07SIP/2.0";
unsigned char method7_k[] = "\x07NOTIFY ";
unsigned char method8_k[] = "\x06PRACK ";
unsigned char method9_k[] = "\x07UPDATE ";
unsigned char method10_k[] = "\x08MESSAGE ";
unsigned char method11_k[] = "\x06REFER ";
unsigned char method12_k[] = "\x0Are-INVITE ";
unsigned char method13_k[] = "\x0ASUBSCRIBE ";



#define  RTP_DYN_TAB_LEN     2000
#define  SIP_DYN_TAB_LEN     20000  
#define RTP_TABLE_LEN        	500
#define SIP_TABLE_LEN		1000
#define TABLE_NULL			0
#define TABLE_USE			2
#define TABLE_DEL			1

struct note_table        /* register IP and port of client */
{
    	unsigned int key_ip;
    	unsigned short key_port;
    	unsigned short sign;
	struct note_table * next;
};

struct nethid_fit
{
	unsigned int ip;
	unsigned char tag;
	unsigned short p_min;
	unsigned short p_max;
	struct nethid_fit * next;
};

#define NETHID_FIT_LEN 20

static struct nf_hook_ops se_voip;    /*hook register struct*/
static struct nf_hook_ops re_voip;


struct note_table  sip_iport_table[SIP_TABLE_LEN];	/*define register table*/
struct note_table  rtp_iport_table[RTP_TABLE_LEN];	/*define register table*/

struct note_table dyn_rtp_table[RTP_DYN_TAB_LEN];
struct note_table dyn_sip_table[SIP_DYN_TAB_LEN];

struct nethid_fit Bl_fit_eth0[NETHID_FIT_LEN];
struct nethid_fit * End_eth0_fit = Bl_fit_eth0;

struct nethid_fit Bl_fit_eth1[NETHID_FIT_LEN];
struct nethid_fit * End_eth1_fit = Bl_fit_eth1;

spinlock_t sip_lock = SPIN_LOCK_UNLOCKED;			/*锁*/
spinlock_t rtp_lock = SPIN_LOCK_UNLOCKED;

unsigned short state_sip_table = 0;
unsigned short state_rtp_table = 0;

EXPORT_SYMBOL(sip_iport_table);				/*全局变量支持*/
EXPORT_SYMBOL(rtp_iport_table);			

EXPORT_SYMBOL(dyn_rtp_table);
EXPORT_SYMBOL(dyn_sip_table);
EXPORT_SYMBOL(Bl_fit_eth0);
EXPORT_SYMBOL(End_eth0_fit);
EXPORT_SYMBOL(Bl_fit_eth1);
EXPORT_SYMBOL(End_eth1_fit);

EXPORT_SYMBOL(sip_lock);
EXPORT_SYMBOL(rtp_lock);

EXPORT_SYMBOL(state_sip_table);
EXPORT_SYMBOL(state_rtp_table);

/*-------------------------------------------------------------------------------
* function   : static void table_init()
* call      : no   
* parameter : no
* return    :  no
* show     : initialize  table
************************************hoohoo**************************************
-------------------------------------------------------------------------------*/
static void __init table_init()
{
	unsigned short num;
	for(num = 0; num < SIP_TABLE_LEN; num++)
	{
		sip_iport_table[num].key_ip = 0;
		sip_iport_table[num].sign = 0;
		sip_iport_table[num].next = 0;
	}
	for(num = 0; num <RTP_TABLE_LEN; num++)
	{
		rtp_iport_table[num].key_ip = 0;
		rtp_iport_table[num].sign = 0;
		rtp_iport_table[num].next = 0;
	}
	for(num = 0; num <SIP_DYN_TAB_LEN; num++)
	{
		dyn_sip_table[num].key_ip = 0;
		dyn_sip_table[num].sign = 0;
		dyn_sip_table[num].next = 0;
	}
	for(num = 0; num <RTP_DYN_TAB_LEN; num++)
	{
		dyn_rtp_table[num].key_ip = 0;
		dyn_rtp_table[num].sign = 0;
		dyn_rtp_table[num].next = 0;
	}
	return;
}
/*-------------------------------------------------------------------------------
* function   : static void methode_init()
* call      : no   
* parameter : no
* return    :  no
* show     : initialize  methode, 
************************************hoohoo**************************************
-------------------------------------------------------------------------------*/

static void __init methode_init()
{
    unsigned short count;
    unsigned short num;
    unsigned char * str;
    
    methode[0] = method0;
    methode[1] = method1;
    methode[2] = method2;
    methode[3] = method3;
    methode[4] = method4;
    methode[5] = method5;
    methode[6] = method6;
    methode[7] = method7;
    methode[8] = method8;
    methode[9] = method9;
    methode[10] = method10;
    methode[11] = method11;
    methode[12] = method12;
    methode[13] = method13;


    methode_key[0] = method0_k;
    methode_key[1] = method1_k;
    methode_key[2] = method2_k;
    methode_key[3] = method3_k;
    methode_key[4] = method4_k;
    methode_key[5] = method5_k;
    methode_key[6] = method6_k;
    methode_key[7] = method7_k;
    methode_key[8] = method8_k;
    methode_key[9] = method9_k;
    methode_key[10] = method10_k;
    methode_key[11] = method11_k;
    methode_key[12] = method12_k;
    methode_key[13] = method13_k;
    

    for(count = 0; count < MOTHOD_LEN;count++)
    {
        str = methode_key[count];    
        for(num = 1; num <= (*str); num ++)
        {
            if((num%2))
                str[num] ^= voip_key_h;
            else
                str[num] ^= voip_key_l;
        }
    }
    return;
}

/*-------------------------------------------------------------------------------
* function : static unsigned int lookup_table(unsigned int tmpip, unsigned short tmport)
* call     :    no
* parameter:  tmpip: ip address,   tmport :  port,  table_piont: 所查的表  len:表的长度
* return   :  0: no register   1: have register
* show     :  lookup register table
************************************hoohoo**************************************
-------------------------------------------------------------------------------*/
static unsigned int lookup_table(unsigned int tmpip, unsigned short tmport,struct note_table * table_point,unsigned short len)
{                                                                /*cha biao*/

	struct note_table * next_point;
	spinlock_t * point_lock;
	unsigned short *state_table;
	unsigned int  sum;
    	sum = tmpip + tmport;
    	sum %= len;

	if(table_point == sip_iport_table)
	{
		point_lock = &sip_lock;
		state_table = &state_sip_table;
	}
	else
	{
		point_lock = &rtp_lock;
		state_table = &state_rtp_table;
	}
	spin_lock(point_lock);
	
/*+++++++++++++++++++++++++++++++++++++++++++++++++*/
	while(*state_table)
	{
		;
	}
	*state_table = 1;

	next_point = table_point + sum;
	while(next_point != 0)	
	{
		if( next_point->key_ip ==  tmpip)
		{
			if(next_point->key_port == tmport)
			{
				next_point->sign = 2;
				*state_table = 0;
				spin_unlock(point_lock);
				return 1;
			}
		}
		next_point = next_point->next;
	}
	*state_table = 0;
	spin_unlock(point_lock);
	return 0;
 
}

/*-------------------------------------------------------------------------------
* function :  
* call     :   
* parameter:   
* return   :   
* show     :  
-------------------------------------------------------------------------------*/
static struct note_table * free_table(struct note_table * table_point) 
{
	unsigned short num;
	unsigned short len = 0;
	struct note_table * free_point = 0;
	if(table_point == sip_iport_table)
	{
		free_point = dyn_sip_table;
		len = SIP_DYN_TAB_LEN;
	}
	if(table_point == rtp_iport_table)
	{
		free_point = dyn_rtp_table;
		len = RTP_DYN_TAB_LEN;
	}
	for(num = 0; num < len; num++)
	{
		if( free_point->sign == 0)
		{
			return free_point;
		} 
		free_point += 1;
	}
	return 0;
}

/*-------------------------------------------------------------------------------
* function : static unsigned int add_table(unsigned int tmpip, unsigned short tmport)
* call     :  
* parameter:  tmpip: ip address,   tmport :  port,  table_piont: 所查的表
* return   :  return 0
* show     :  add register
************************************hoohoo**************************************
-------------------------------------------------------------------------------*/
static unsigned int add_table(unsigned int tmpip, unsigned short tmport,struct note_table * table_point, unsigned short len)        
{
    	struct note_table * next_point;
	unsigned int  sum;
	spinlock_t * point_lock;
	unsigned short *state_table;
    	sum = tmpip + tmport;
    	sum %= len;
	if(table_point == sip_iport_table)
	{
		point_lock = &sip_lock;
		state_table = &state_sip_table;
	}
	else
	{
		point_lock = &rtp_lock;
		state_table = &state_rtp_table;
	}
	spin_lock(point_lock);
	
/*+++++++++++++++++++++++++++++++++++++++++++++++++*/
	while(*state_table)
	{
		;
	}
	*state_table = 1;

	next_point = table_point + sum;
	if(next_point->sign == 0)
	{
		next_point->key_ip = tmpip;
		next_point->key_port =  tmport;
		next_point->sign = 2;
		next_point->next = 0;
		*state_table = 0;
		spin_unlock(point_lock);
		return 0;
	}
    
	while(next_point != 0)	
	{
		if( next_point->key_ip ==  tmpip)
		{
			if(next_point->key_port == tmport)
			{
				*state_table = 0;
				spin_unlock(point_lock);
				return 1;
			}
		}
		if( next_point->next == 0)
		{
			next_point->next = free_table(table_point); 
			if(next_point->next == 0)
			{
				*state_table = 0;
				spin_unlock(point_lock);
				return 0;
			}
			next_point = next_point->next;
			next_point->key_ip = tmpip;
			next_point->key_port =  tmport;
			next_point->sign = 2;
			next_point->next = 0;
			*state_table = 0;
			spin_unlock(point_lock);
			return 0;
		}
		next_point = next_point->next;
	}
	*state_table = 0;
	spin_unlock(point_lock);
	return 0;
}
/*-------------------------------------------------------------------------------
* function : static unsigned int del_table(unsigned int tmpip, unsigned short tmport)
* call     :   unsigned int lookup_table(unsigned int tmpip, unsigned short tmport)  
* parameter:  tmpip: ip address,   tmport :  port,  table_piont: 所查的表
* return   :  return 0
* show     :  add register
************************************hoohoo**************************************
-------------------------------------------------------------------------------*/
static unsigned int del_table(unsigned int tmpip, unsigned short tmport,struct note_table * table_point, unsigned short len)        
{
   	struct note_table * next_point;
	struct note_table * tmp_point;
	spinlock_t * point_lock;
	unsigned short *state_table;
	unsigned int  sum;
    	sum = tmpip + tmport;
    	sum %= len;
	
	if(table_point == sip_iport_table)
	{
		point_lock = &sip_lock;
		state_table = &state_sip_table;
	}
	else
	{
		point_lock = &rtp_lock;
		state_table = &state_rtp_table;
	}
	spin_lock(point_lock);
	
/*+++++++++++++++++++++++++++++++++++++++++++++++++*/
	while(*state_table)
	{
		;
	}
	*state_table = 1;

	next_point = table_point + sum;

	if( next_point->key_ip ==  tmpip)
	{
		if(next_point->key_port == tmport)
		{
			if(next_point->next != 0)
			{
				next_point->key_ip = (next_point->next)->key_ip;
				next_point->key_port = (next_point->next)->key_port;
				next_point->sign = (next_point->next)->sign;
				(next_point->next)->key_ip = 0;
				(next_point->next)->key_port = 0;
				(next_point->next)->sign = 0;
				tmp_point = (next_point->next)->next;
				(next_point->next)->next = 0;
				next_point->next = tmp_point;

				*state_table = 0;
				spin_unlock(point_lock);
				return 0;
			}
				next_point->key_ip = 0;
				next_point->sign = 0;
				*state_table = 0;
				spin_unlock(point_lock);
				return 0;
		}
	}    

	while(next_point->next != 0)	
	{
		if( (next_point->next)->key_ip ==  tmpip)
		{
			if((next_point->next)->key_port == tmport)
			{
				(next_point->next)->key_ip = 0;
				(next_point->next)->key_port = 0;
				(next_point->next)->sign = 0;
				tmp_point = (next_point->next)->next;
				(next_point->next)->next = 0;
				next_point->next = tmp_point;

				*state_table = 0;
				spin_unlock(point_lock);
				return 1;
			}
		}
		next_point = next_point->next;
	}
	*state_table = 0;
	spin_unlock(point_lock);
	return 0;
}
/*-------------------------------------------------------------------------------
* function :  static unsigned int packet_key(unsigned short *buffer, unsigned short len)
* call     :    no
* parameter:  buffer: udp data point,   len ,udp packet length
* return   :   return 0
* show     :  encrypt and decode
************************************hoohoo**************************************
-------------------------------------------------------------------------------*/
static unsigned int packet_key(unsigned short *buffer, unsigned short len)  
{
    if(len%2)
    {
        *(((unsigned char *)buffer) + len -1)   ^=  VOIP_KEY_end;
        
    }
    len >>= 1;
    while(len)
    {
        *buffer = (*buffer) ^ voip_key;
        buffer++;
        len--;
    }
    return 0;
}

/*-------------------------------------------------------------------------------
* function : static unsigned short cksum_udp(unsigned int * ip_saddr,       : source ip
                       unsigned int * ip_daddr, 		   : dest ip
                       unsigned short * udp_buff,		   : udp data packet point
                       unsigned short len)                     :udp data packet length
* call     :    no
* parameter:
* return   :   return check;
* show     :  accout checksum
************************************hoohoo**************************************
-------------------------------------------------------------------------------*/
static unsigned short cksum_udp(unsigned int * ip_saddr, 
                       unsigned int * ip_daddr, 
                       unsigned short * udp_buff,
                       unsigned short len)        
{
    unsigned short * ips = (unsigned short * )ip_saddr;
    unsigned short * ipd = (unsigned short * )ip_daddr;
    unsigned char * prc = "\x0\x11";
    unsigned int sum = 0;
    unsigned short num;

    sum += * ips;
    sum += * (ips + 1);
    sum += * ipd;
    sum += * (ipd + 1);
    sum += * ((unsigned short *)prc);
    sum += ((len>>8) & 0xff) | ((len<<8) & 0xff00);
    if(len%2)
    {
        *(((unsigned char *)udp_buff) + len) = 0;
        len++;
    }
    len >>=1;
    for(num = 0; num < len; num++)
    {
        sum += * udp_buff;
        udp_buff++;
    }

    sum = (sum>>16) + (sum & 0xffff);
    sum += (sum>>16);
    return (unsigned short)(~sum & 0xffff);
}

/*-------------------------------------------------------------------------------
* function : static unsigned int diff_sip(unsigned char *buffer, unsigned int ip_saddr,unsigned short len) 
* call     :    int atoi(char * str)
* parameter: buffer : sip data packet point  , ip_saddr: source ip  len: sip data packet length 
* return   :    0:  no sip packet    1: sip packet
* show     : judge data packet 
************************************hoohoo**********************
-------------------------------------------------------------------------------*/
static unsigned int diff_sip(unsigned char *buffer, unsigned int ip_saddr,unsigned short len,unsigned char ** methode_tmp)       
{
        unsigned short num;
        unsigned char *str;
	  unsigned char i;

     for(i = 0; i < MOTHOD_LEN; i++)
      {
       if(*buffer == *(methode_tmp[i] + 1))  
        {
	            str = methode_tmp[i] + 2;
	            for(num = 1; num < (* methode_tmp[i]) ; num++)
	            {
	                if(*(buffer + num) != * str)
	                {
	                    return 0;
	                }
	                str++;
	            }
	
            return 1;
        }
      }                        
     return 0;

}

/*-------------------------------------------------------------------------------
* function : static unsigned short diff_rtp(unsigned char *buffer, unsigned char *sign)
* call     :    
* parameter: buffer: 数据缓冲区  sign : 标志位 1, 判断加密数据; 0,判断未加密数据
* return   : 是rtp: 返回1, 不是rtp: 返回0
* show     :
************************************hoohoo**************************************
-------------------------------------------------------------------------------*/
static unsigned short diff_rtp(unsigned char *buffer, unsigned char sign)
{
	if(sign == 1)
	{    
	    if( (((*buffer) ^ voip_key_h) >> 6) == 2)
	    {
	        if( ( ( (*(buffer + 1) ) ^ voip_key_l) & 0x7f ) < 34)
	        {
	            return 1;
	        }
	    }
	    return 0;
	}
	if(sign == 0)
	{
	     if( ((*buffer)  >> 6) == 2)
	    {
	        if( ( (*(buffer + 1) ) & 0x7f ) < 34)
	        {
	            return 1;
	        }
	    }
	    return 0;
	}
	return 0;
}

/*-------------------------------------------------------------------------------
* function : static unsigned short diff_rtcp(unsigned char *buffer, unsigned char sign)
* call     :    
* parameter: buffer: 数据缓冲区  sign : 标志位 1, 判断加密数据; 0,判断未加密数据
* return   :  是rtcp: 返回1, 不是rtcp: 返回0
* show     :
************************************hoohoo**************************************
-------------------------------------------------------------------------------*/
static unsigned short diff_rtcp(unsigned char *buffer, unsigned char sign)
{
	if(sign == 1)
	{    
	    if( (((*buffer) ^ voip_key_h) >> 6) == 2)
	    {
	        if( (((*(buffer + 1)) ^ voip_key_l) > 199) && (((*(buffer + 1)) ^ voip_key_l) < 205))
	        {
	                if(((*(buffer + 1)) ^ voip_key_l) == 203)
			{
				return 2;
			}
			return 1;
	        }
	    }
	    return 0;
	}
	if(sign == 0)
	{    
	    if( ((*buffer)  >> 6) == 2)
	    {
	        if( ((*(buffer + 1))> 199) && ((*(buffer + 1)) < 205))
	        {
			if((*(buffer + 1)) == 203)
			{
				return 2;
			}
	            return 1;
	        }
	    }
	    return 0;
	}
	return 0;
}

/*-------------------------------------------------------------------------------
* function :  
* call     :   
* parameter:   
* return   :   
* show     :  
-------------------------------------------------------------------------------*/
static int nethid_fit(unsigned int ip_s, unsigned int ip_d, unsigned short port_s, unsigned short port_d, struct nethid_fit * fit, struct nethid_fit * end_fit)
{
	struct nethid_fit * tmp_point = fit;

	port_s = ((port_s>>8) & 0xff) | ((port_s<<8) & 0xff00);
	port_d = ((port_d>>8) & 0xff) | ((port_d<<8) & 0xff00);


	while(tmp_point != end_fit)
	{
		if(tmp_point->tag == 's')
		{
			if((tmp_point->ip != 0xffffffff) && (tmp_point->ip != ip_s))
			{
				tmp_point++;
				continue;
			}
			if((port_s >= tmp_point->p_min) && (port_s <= tmp_point->p_max))
			{
				return 1;
			}
			tmp_point++;
			continue;
		}
		if(tmp_point->tag == 'd')
		{
			if((tmp_point->ip != 0xffffffff) && (tmp_point->ip != ip_d))
			{
				tmp_point++;
				continue;
			}
			if((port_d >= tmp_point->p_min) && (port_d <= tmp_point->p_max))
			{
				return 1;
			}
		}
		tmp_point++;
	}
	return 0;
}

/*-------------------------------------------------------------------------------
* function : 
* call     :    
* parameter:
* return   :
* show     :
************************************hoohoo**************************************
-------------------------------------------------------------------------------*/
unsigned int hook_sefunc(unsigned int hooknum,
		struct sk_buff **skb,
		const struct net_device *in,
		const struct net_device *out,
		int(*okfn)(struct sk_buff *))
{

	unsigned short num = 0;    

    /***** code ******/
   	struct sk_buff *sb = *skb;
 	struct udphdr *thdr;
	unsigned short *tmpdata;
 	unsigned int tmplen;
    	
	/*
   	if(!sb) return NF_ACCEPT;
 	if(!(sb->nh.iph)) return NF_ACCEPT;
 	if(sb->nh.iph->protocol != IPPROTO_UDP) return NF_ACCEPT; 
*/

	/* 2.6.1* */
	/*skb_linearize(sb);*/	   /*线性化数据包*/

	thdr = (struct udphdr *)(sb->data + (sb->nh.iph->ihl * 4));
	tmpdata = (unsigned short *)(sb->data + (sb->nh.iph->ihl * 4) + 8); 
	tmplen = sb->len - (sb->nh.iph->ihl * 4); 			/*udp 包 长度 */ 

/*
	if( (((thdr->source>>8) & 0xff) | ((thdr->source<<8) & 0xff00)) < 0x0400) return NF_ACCEPT; 
	if( (((thdr->dest>>8) & 0xff) | ((thdr->dest<<8) & 0xff00)) < 0x0400)  return NF_ACCEPT; 
*/
	
	/*service access port 服务器外发数据,  对数据包进行加密*/
	if(nethid_fit(sb->nh.iph->saddr, sb->nh.iph->daddr, thdr->source, thdr->dest, Bl_fit_eth1, End_eth1_fit))
	{/*直通处理*/
		return NF_ACCEPT; 
	}	
	if(diff_rtp((unsigned char *)tmpdata, 0))
	{
		if (!(lookup_table(sb->nh.iph->daddr, thdr->dest, rtp_iport_table,RTP_TABLE_LEN)))
		{
			return NF_ACCEPT;
		}
	} 
	else
	{
		if(diff_sip((unsigned char *)tmpdata, sb->nh.iph->daddr,(tmplen - 8), methode))
		{
			if (!(lookup_table(sb->nh.iph->daddr, thdr->dest, sip_iport_table,SIP_TABLE_LEN)))
			{
				return NF_ACCEPT;
			}
		}
		else
		{
			if( (num = diff_rtcp((unsigned char *)tmpdata, 0))) 
			{
				if (!(lookup_table(sb->nh.iph->daddr, (thdr->dest - 1), rtp_iport_table,RTP_TABLE_LEN)))
				{
					return NF_ACCEPT;
				}
				if(num == 2)
				{
					del_table(sb->nh.iph->daddr, (thdr->dest - 1), rtp_iport_table,RTP_TABLE_LEN) ;
				}
			}
			else
			{
					return NF_ACCEPT; 
			}
		}
	}
    	if (thdr->check !=0)                                
	{
        	if ( cksum_udp(&(sb->nh.iph->saddr) ,&(sb->nh.iph->daddr), (unsigned short *)thdr, tmplen) )
       	{/* check wrong */
              	 return NF_DROP;        
           	}
         	/*^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^*/
       	packet_key(tmpdata, (tmplen - 8));  
	
	      	thdr->check = 0;
		thdr->check = cksum_udp(&(sb->nh.iph->saddr) ,&(sb->nh.iph->daddr), (unsigned short *)thdr, tmplen);                
	}
	else
	{
	     packet_key(tmpdata, (tmplen - 8));        
	}		
	return NF_ACCEPT;            

}
/*-------------------------------------------------------------------------------
* function : 
* call     :    
* parameter:
* return   :
* show     :
************************************hoohoo**************************************
-------------------------------------------------------------------------------*/
unsigned int hook_refunc(unsigned int hooknum,
		struct sk_buff **skb,
		const struct net_device *in,
		const struct net_device *out,
		int(*okfn)(struct sk_buff *))
{

	 unsigned short num = 0;   
 

    /***** code ******/
   	   struct sk_buff *sb = *skb;
 	   struct udphdr *thdr;
	   unsigned short *tmpdata;
 	   unsigned int tmplen;
    	
   	if(!sb) return NF_ACCEPT;
 	if(!(sb->nh.iph)) return NF_ACCEPT;
 	if(sb->nh.iph->protocol != IPPROTO_UDP) return NF_ACCEPT; 

	/* 2.6.1* */
	/*skb_linearize(sb);*/	

	thdr = (struct udphdr *)(sb->data + (sb->nh.iph->ihl * 4));
	tmpdata = (unsigned short *)(sb->data + (sb->nh.iph->ihl * 4) + 8); 
	tmplen = sb->len - (sb->nh.iph->ihl * 4); 			/*udp 包 长度 */ 

	/*route access port, client data 客户端来的数据, 对数据包进行解密*/ 

	if(nethid_fit(sb->nh.iph->saddr, sb->nh.iph->daddr, thdr->source, thdr->dest, Bl_fit_eth0, End_eth0_fit))
	{/*直通处理*/	
		return NF_ACCEPT; 
	}		
	if(diff_sip((unsigned char *)tmpdata, sb->nh.iph->saddr,(tmplen - 8), methode))
	{/*是否为标准SIP包*/
		del_table(sb->nh.iph->saddr, thdr->source, sip_iport_table,SIP_TABLE_LEN);
		if(net_state == 0x626c)
		{/*判断是否丢弃正常SIP包*/
			return NF_DROP;        /*discard data packet*/
		}
		return NF_ACCEPT;
	}
	if(diff_rtp((unsigned char *)tmpdata, 1)) 
	{
		add_table(sb->nh.iph->saddr, thdr->source, rtp_iport_table, RTP_TABLE_LEN);        /*lookup and add register*/
	}
	else 
	{
		if( diff_sip((unsigned char *)tmpdata, sb->nh.iph->saddr,(tmplen - 8), methode_key))
		{/*是否为加密SIP包*/
			add_table(sb->nh.iph->saddr, thdr->source, sip_iport_table,SIP_TABLE_LEN);        /*lookup and add register*/
		}
		else
		{	
			if( (num = diff_rtcp((unsigned char *)tmpdata, 1))) 
			{
				if(num == 1)
				{
					add_table(sb->nh.iph->saddr, (thdr->source - 1), rtp_iport_table, RTP_TABLE_LEN);        /*lookup and add register*/
				}
				else
				{
					del_table(sb->nh.iph->saddr, (thdr->source - 1), rtp_iport_table,RTP_TABLE_LEN) ;
				}
			}
			else
			{
				return NF_ACCEPT; 
			}
		  }                       
	}
	if (thdr->check !=0)                                
	{
		if (cksum_udp(&(sb->nh.iph->saddr) ,&(sb->nh.iph->daddr), (unsigned short *)thdr, tmplen) != 0) 
		{/* check wrong */
			return NF_DROP;        /*discard data packet*/
	       	}
		packet_key(tmpdata, (tmplen - 8));  
		thdr->check= 0;
		thdr->check = cksum_udp(&(sb->nh.iph->saddr) ,&(sb->nh.iph->daddr), (unsigned short *)thdr, tmplen);        
	}
	else
      {/* no check*/
         	  packet_key(tmpdata, (tmplen - 8));            
	}

	return NF_ACCEPT; 
}


/*-------------------------------------------------------------------------------
* function : 
* call     :    
* parameter:
* return   :
* show     :
************************************hoohoo**************************************
-------------------------------------------------------------------------------*/
int init_module(void)
{
	
	if((net_state & 0x0fff0) != 0x6260)   /*判断参数,决定是否处理数据包,最低四位决定对正常SIP包的处理,为0,通过,否则丢弃*/
	{
		voip_key = 0x00;
		printk("-- start unsuccessful--\n"); 
	}
	else
	{
		printk("-- start successful--\n");
	}
	voip_key_h = (unsigned char)(voip_key & 0xff);
	voip_key_l = (unsigned char)((voip_key >> 8) & 0xff);
	table_init();
	methode_init(); 
           
	se_voip.hook = hook_sefunc;
	se_voip.hooknum = NF_IP_LOCAL_OUT;			/*挂载点 NF_IP_LOCAL_OUT,来自本机进程的数据包在离开本地主机的过程中*/
	se_voip.pf = PF_INET;
	se_voip.priority = NF_IP_PRI_LAST;			/*执行顺序最末*/

	nf_register_hook(&se_voip);


	re_voip.hook = hook_refunc;
	re_voip.hooknum = NF_IP_LOCAL_IN;			/*挂载点 NF_IP_LOCAL_IN, 在选路确定之后,且数据包*/
	re_voip.pf = PF_INET;
	re_voip.priority = NF_IP_PRI_FIRST;			/*执行顺序最早*/

	nf_register_hook(&re_voip);

	

	
	return 0;
}

/*-------------------------------------------------------------------------------
*    function	: 
*    call		:    
*   parameter	:
*   return	:     
*   show    	:
***********************hoho*******************************
-------------------------------------------------------------------------------*/
void cleanup_module(void)
{
	
	nf_unregister_hook(&se_voip);
	nf_unregister_hook(&re_voip);
}

/*
module_init(neth_init);  
module_exit(neth_exit);  
*/
MODULE_LICENSE("GPL");

MODULE_AUTHOR(DRIVER_AUTHOR );
MODULE_DESCRIPTION(DRIVER_DESC);
